3740. 三个相等元素之间的最小距离 I

3740. 三个相等元素之间的最小距离 I

提示

给你一个整数数组 nums。

如果满足 nums[i] == nums[j] == nums[k],且 (i, j, k) 是 3 个 不同 下标,那么三元组 (i, j, k) 被称为 有效三元组。

有效三元组 的 距离 被定义为 abs(i - j) + abs(j - k) + abs(k - i),其中 abs(x) 表示 x 的 绝对值。

返回一个整数,表示 有效三元组 的 最小 可能距离。如果不存在 有效三元组 ,返回 -1。

示例 1:

输入: nums = 1,2,1,1,3

输出: 6

解释:

最小距离对应的有效三元组是 (0, 2, 3) 。

(0, 2, 3) 是一个有效三元组,因为 nums[0] == nums[2] == nums[3] == 1。它的距离为 abs(0 - 2) + abs(2 - 3) + abs(3 - 0) = 2 + 1 + 3 = 6。

示例 2:

输入: nums = 1,1,2,3,2,1,2

输出: 8

解释:

最小距离对应的有效三元组是 (2, 4, 6) 。

(2, 4, 6) 是一个有效三元组,因为 nums[2] == nums[4] == nums[6] == 2。它的距离为 abs(2 - 4) + abs(4 - 6) + abs(6 - 2) = 2 + 2 + 4 = 8。

示例 3:

输入: nums = 1

输出: -1

解释:

不存在有效三元组,因此答案为 -1。

提示:

  • 1 <= n == nums.length <= 100

  • 1 <= nums[i] <= n

    class Solution {
    public:
    int minimumDistance(vector& nums) {

    复制代码
          vector<vector<int>>q;
          q.resize(101);  
          int pos=0;
          for(auto it:nums){
              q[it].push_back(pos);
              pos++;
          }
          int minn=-1;
          for(int i=0;i<=100;i++){
              if(q[i].size()>=3){
                  if(minn==-1)minn=500;
                  for(int j=2;j<q[i].size();j++){
                      minn=min(minn,2*(q[i][j]-q[i][j-2]));
                  }
              }
          }
          return minn;
      }

    };

相关推荐
dialect_5 小时前
KMP算法
开发语言·c++·算法
reikocao5 小时前
卡尔曼滤波的动态机制:P如何改变融合权重
算法
漂流瓶jz6 小时前
UVA-1612 猜名次 题解答案代码 算法竞赛入门经典第二版
数据结构·算法·题解·排序·aoapc·算法竞赛入门经典
吞下星星的少年·-·6 小时前
Div.2 CF 1130B题(构造,贪心)
算法·贪心·构造
ShineWinsu7 小时前
对于Qt:QRadioButton常见属性以及QButtonGroup的解析
数据库·c++·qt·microsoft·gui·qradiobutton·qbuttongroup
傲世仙尊7 小时前
多态-虚表才活到运行期符号表早已消失
c++
chenbingjie_c7 小时前
C++ 多态完全指南:从虚函数重写到虚函数表原理
开发语言·c++
是main不是漫7 小时前
【双指针——移动零】数组划分类题目的入门基石
c++·算法
·present·7 小时前
CSAPP(Bomb lab)
c语言·c++
王老师青少年编程8 小时前
2026年信奥赛c++普及组csp-j第二轮复赛真题
c++·真题·csp·信奥赛